<template>
  <section mode-entry :active="!!activeVersion" @click="select()">
    <span>{{modeEntry.name}}</span>
    <md-menu md-align-trigger>
      <span md-menu-trigger @click.stop="">{{activeVersion || defaultVersion}} <md-icon md-src="/img/md/arrow_drop_down.svg"/></span>
      <md-menu-content mode-entry-menu>
        <p v-for="modeVersion in modeEntry.keys" :key="modeVersion.version" @click="select(modeVersion.version)">{{modeVersion.version}}</p>
      </md-menu-content>
    </md-menu>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';
import { MdSwitch } from 'vue-material/dist/components';
import { store } from '../../store';
import { KeyPathKey } from '../../store/editor';
import axios from '../../lib/axios';

Vue.use(MdSwitch);
@Component({
  components: {
  },
})
export default class extends Vue {
  @Prop()
  private modeEntry: any;
  @Prop()
  private activeValue!: string;

  private select(version) {
    if (!version) {
      version = this.defaultVersion;
    }
    const id = this.modeEntry.keys.find(k => k.version === version).row.ID;
    this.$emit('modeselected', id);
  }

  get activeVersion() {
    if (!this.modeEntry) {
      return;
    }
    const activeKey = this.modeEntry.keys.find(k => k.row.ID === this.activeValue);
    if (!activeKey) {
      return;
    }
    return activeKey.version;
  }

  get defaultVersion() {
    if (!this.modeEntry || !this.modeEntry.keys[0]) {
      return '?';
    } else {
      return this.modeEntry.keys[0].version;
    }
  }
}
</script>

<style scoped lang="scss">
[mode-entry] {
  min-height: 2.2em;
  padding: 0 10px;
  display: flex;
  align-items: center;
  justify-content: space-between;

  &[active] {
    @include md-theme-property(background, accent, "primary");
  }

  [md-menu-trigger] {
    display: flex;
    flex-direction: row;
  }
}
[mode-entry-menu] {
  min-width: 0;
  p {
    margin: .5em 1em;
  }
}
</style>
<style lang="scss">
[mode-entry] {
  .md-icon.md-icon.md-icon svg {
    @include md-theme-property(fill, text-primary, "primary");
  }
}
</style>